/****************************************************************************

  example2.cpp

  A simple GLUT program using the GLUI User Interface Library

  -----------------------------------------------------------------------
	    
    
 
****************************************************************************/
 
#include <string.h>
#include <GL/glut.h>
#include "./glui.h" 
#include <time.h>
#include <stdio.h> 
#include "./distort.h"
#include "./Key.h" 
#include "./Fileio.h" 
#include "./curvefunc.h" 

  
    
     
 
 
float ctrlpoints[3][2] ={{0.0,0.0},{0.0,1.0},{1.0,1.0}},xc= 0.0 , yc= 1.0; 
float pi = 3.1415926535;
float xy_aspect; 
int   last_x, last_y, frame = 2, stop  = 0, sininout =0;
float rotationX = 0.0, rotationY = 0.0;
int   main_window;
float  currentx, currenty, curposx, curposy, curpol; 
int length = 100;
int zx = 50000;
/** These are the live variables passed into GLUI ***/
int   wireframe = 0;
int   obj = 0;
int   segments = 8;
char  text[200] = {"Milod v1.5"}; 
 int mulsw = 0;
 int multi = 0;
GLUI *cmd_line_glui, *glui, *curve_glui;
GLUI_Checkbox   *checkbox;
GLUI_Spinner    *spinner;
GLUI_RadioGroup *radio;
GLUI_EditText   *edittext, *cmd_line;
 
 
void myGlutDisplay( void ); 
void drawcurve(void);
/**************************************** control_cb() *******************/
/* GLUI control callback                                                 */

void control_cb( int control )
{

}
 
 
 

/**************************************** myGlutKeyboard() **********/
 
   
    
  
float lintp(float a, float b, float t_val) 
{ 
return a + (b - a)*t_val; 
} 
 
int isempty(KEYFRAMEPTR sptr) 
{ 
	return sptr == NULL; 
} 
 
 
 
void interpolkeys(KEYFRAMEPTR *sptr, int time_l, int segf) 
{ 
KEYFRAMEPTR currentptr, nextptr; 
float  t; 
int i,k, no_of_fs,frame_no; 
currentptr =  (*sptr); 
nextptr = (*sptr)->Next_key; 
currentx = currentptr->x_co; 
currenty = currentptr->y_co;
curposx = currentptr->posxx;
curposy = currentptr->posyy; 
curpol = currentptr->pola;

for ( k=0; k<=currentptr->f_no -1;k++)  /*blank frames - no keys*/ 
{ 
frame_no= k; 
xc = currentx;              
yc = currenty;
 polmax = curpol;
pph = curposy;
ppw = curposx;
frame = k; 
curve_glui->sync_live();
do_whole_image(xc,yc, pph, ppw, polmax); 
myGlutDisplay(); 
 
for (int z = 0; z <= zx; z++);  { } 
} 
 
 
/* bit to print just the very first frame */ 
currentx = lintp(currentptr->x_co, nextptr->x_co, 0); 
currenty = lintp(currentptr->y_co, nextptr->y_co, 0);
curposx = lintp(currentptr->posxx, nextptr->posxx, 0); 
curposy = lintp(currentptr->posyy, nextptr->posyy, 0); 
curpol = lintp(currentptr->pola, nextptr->pola, 0);

xc = currentx;              
yc = currenty;
polmax = curpol;
pph = curposy;
ppw = curposx;
++frame_no; 
curve_glui->sync_live();
do_whole_image(xc,yc, pph, ppw, polmax); 
myGlutDisplay();
				
/* end proberbly should put  update do whole image here*/ 
 
  while(currentptr->Next_key != NULL && currentptr->f_no <= time_l)  /*while keyframes*/
	  { 
	  no_of_fs = (nextptr->f_no) - (currentptr->f_no); 
		for(i =1; i<= no_of_fs ; i++) 
		     { 
		     if (frame_no < time_l) 
		       { 
			t= (float) i/no_of_fs;
				if (sininout ==1)
					{
					t= ((sin(( t*pi)- (pi/2))+1)/2);
					}
			currentx = lintp(currentptr->x_co, nextptr->x_co, t); 
			currenty = lintp(currentptr->y_co, nextptr->y_co, t);
 			curposx = lintp(currentptr->posxx, nextptr->posxx, t); 
			curposy = lintp(currentptr->posyy, nextptr->posyy, t); 
			curpol = lintp(currentptr->pola, nextptr->pola, t);
			polmax = curpol;
			pph = curposy;
			ppw = curposx;
			xc= currentx; 
			yc= currenty; 
			frame = frame_no;
			curve_glui->sync_live();
			do_whole_image(xc,yc,pph, ppw, polmax); 
			myGlutDisplay();  
   				for (int z = 0; z <= zx; z++);  { }
			++frame_no;	 
		        } 
 
	             } 
	   currentptr = nextptr; 
	   nextptr = nextptr->Next_key; 
	} 

  for (int n=currentptr->f_no + 1; n<=time_l;n++)  /*blank frames - no keys*/ 
  { 
	xc= currentx; 
	yc= currenty;
 	polmax = curpol;
	pph = curposy;
	ppw = curposx;
	frame = n;
	curve_glui->sync_live();
	do_whole_image(xc,yc, pph, ppw, polmax); 
	myGlutDisplay(); 
	for (int z = 0; z <= zx; z++);  
		{ 
		} 
  }
 
} 
 
  
  
 
float percent(int a, int b) 
 { 
  float t; 
	if (b > 0.0) 
		t = (float) b/a; 
	else  
	      t=0; 
  return t; 
} 
void getu(float *vx, float *vy, float ax, float ay, float bx,float by,float cx,float cy,float t) 
{ 
  float ix,iy,jx,jy;  
	ix = lintp(ax,bx,t); 
	iy = lintp(ay,by,t); 
	jx = lintp(bx,cx,t); 
	jy = lintp(by,cy,t); 
	*vx = lintp(ix,jx,t); 
	*vy = lintp(iy,jy,t); 
} 
 
 
void drawcurve(void) 
{ 
 int i,p=30;                            /*i counter and p is the number of pieces the curve is divided into */ 
 float xa,ya,v;                           /*v is percent of curve (t)*/ 
 
   ctrlpoints[1][0] = xc;             /*start and end points of the curve which do not change*/ 
   ctrlpoints[1][1] = yc; 
 
  
glColor3f(0.0, 1.0, 0.0); 
    glBegin(GL_LINE_STRIP); 
       for (i = 0; i <= p; i++)  
		{ 
		 v = percent(p,i); 
		 getu(&xa, &ya, 0.0,0.0,xc,yc,1.0,1.0,v); 
		 glVertex3f(xa,ya,0.0); 
		}         
     glEnd(); 
 
   /* The following code displays the control hull. */ 
 
   glPointSize(5.0); 
   glColor3f(1.0, 1.0, 0.0); 
   glBegin(GL_LINE_STRIP); 
      for (i = 0; i < 3; i++)  
         glVertex2fv(&ctrlpoints[i][0]); 
   glEnd(); 
    
   glPushMatrix(); 
   glTranslatef( ctrlpoints[1][0],ctrlpoints[1][1],0); 
     glutSolidCube (0.025); 
    glPopMatrix(); 
 
glPushMatrix(); 
   glTranslatef( ctrlpoints[0][0],ctrlpoints[0][1],0); 
   glutSolidCube (0.025); 
glPopMatrix(); 
glPushMatrix(); 
   glTranslatef( ctrlpoints[2][0],ctrlpoints[2][1],0); 
   glutSolidCube (0.025); 
glPopMatrix(); 
} 
 
 

void myGlutKeyboard(unsigned char Key, int x, int y)
{
  switch(Key)
  {
  case 27: 
  case 'q':
    exit(0);
    break;
  };
   
  glutPostRedisplay();  
}

void bob(int control) 
{ 
switch (control)  
{ 
		case 1: 
			insert(&startptr, xc, yc, ppw, pph, polmax,frame); 
			printlist(startptr); 
			break; 
 
		case 2: 
			if (!isempty(startptr)) 
			{ 
				printf ("enter keyframe to be deleted:\n"); 
				 
 
				if (deletef(&startptr, frame)) 
					{ 
					printf (" keyframe %d  deleted \n\n.", frame); 
					} 
			else 
				printf (" keyframe %d  not found.\n\n", frame);	 
			    printlist(startptr); 
			} 
			else 
				printf("list is empty.\n\n"); 
			break; 
 
		case 3: 
				stop = 1;
				ren =0; 
				pla =1;
				inframe =0;
				interpolkeys(&startptr, length, 1);  /* the '1' here is a flag to say no seqence*/
				
			break; 
		case 4: 
				   ctrlpoints[1][0] = xc;             /*start and end points of the curve which do not change*/ 
			break;	 
               case 5: 
                           ctrlpoints[1][1] = yc; 
			break; 
		case 6: 
				stop = 1;
				ren =1;
				pla = 0;
				inframe =0;
				interpolkeys(&startptr, length, multi); 
				
			break;
		case 7: 
				stop =0;   /* at the moment can inturupt function so no real point*/
				 
			break; 
		default: 
			printf("invalid choice\n"); 
			break; 
 
				}   
}     
        
void ralph( int control )  
{ 
switch (control)  
{ 
		case 1: 
			filesave(&startptr);  
		break; 
 
                case 2: 
			fileopen();  
		break;  
 
		case 3: 
				printlist(startptr);   
			break;
		case 4: 
				do_whole_image(xc,yc, pph, ppw, polmax); 
			break;
 		case 5: 
				do_whole_image(xc,yc, pph, ppw, polmax); 
			break;
		case 6: 
				do_whole_image(xc,yc, pph, ppw, polmax); 
			break;
 		case 7: 
				do_whole_image(xc,yc, pph, ppw, polmax); 
			break;
		case 8:  
			/*if (mulsw)
				{
				multi = 2;  
				}
			else
				{
				multi = 0;
				}*/
			break;
		default: 
			printf("invalid choice\n"); 
			break; 
 
				} 
 
}
/***************************************** myGlutMenu() ***********/

void myGlutMenu( int value )
{
  myGlutKeyboard( value, 0, 0 );
}

 
/***************************************** myGlutIdle() ***********/

void myGlutIdle( void )
{
  /* According to the GLUT specification, the current window is 
     undefined during an idle callback.  So we need to explicitly change
     it if necessary */
  if ( glutGetWindow() != main_window) 
    glutSetWindow(main_window);  

  glutPostRedisplay();
}

/***************************************** myGlutMouse() **********/

void myGlutMouse(int button, int button_state, int xm, int ym )
{
  if ( button == GLUT_LEFT_BUTTON && button_state == GLUT_DOWN ) {
    last_x = xm;
    last_y = ym;

  }
}
 

/***************************************** myGlutMotion() **********/

void myGlutMotion(int xm, int ym )
{
  xc += (float) (xm - last_x)*0.0054; 
  yc += (float) (ym - last_y)*-0.0054; 
 
curve_glui->sync_live(); 
  last_x = xm; 
  last_y = ym; 
 
  glutPostRedisplay();
}

/**************************************** myGlutReshape() *************/

void myGlutReshape( int x, int y )
{
  xy_aspect = (float)x / (float)y;
  glViewport( 0, 0, x, y );

  glutPostRedisplay();
}

/***************************************** myGlutDisplay() *****************/

static void myGlutDisplay( void )
{
  glClearColor( .9f, .9f, .9f, 1.0f );
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT ); 


 glMatrixMode(GL_PROJECTION); 
  glLoadIdentity(); 
  gluPerspective( 40.0,300/300,2.0, 40.00); 
 
glMatrixMode(GL_MODELVIEW); 
  glLoadIdentity(); 
    glPushMatrix(); 
      glTranslatef( -0.4, -0.4, -2.2);	 
       drawcurve(); 
    glPopMatrix();

  




  glDisable( GL_LIGHTING );  /* Disable lighting while we render text */
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluOrtho2D( 0.0, 100.0, 0.0, 100.0  );
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  glColor3ub( 0, 0, 0 );
  glRasterPos2i( 10, 10 );

  //  printf( "text: %s\n", text );

  /*** Render the live character array 'text' ***/
  int i;
  for( i=0; i<(int)strlen( text ); i++ )
    glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, text[i] );

  glEnable( GL_LIGHTING );

  glutSwapBuffers(); 
}


/**************************************** main() ********************/

void main(int argc, char* argv[])
{
  /****************************************/
  /*   Initialize GLUT and create window  */
  /****************************************/

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
  glutInitWindowPosition( 30, 30 );
  glutInitWindowSize( 300, 300 );
 
  main_window = glutCreateWindow( "GLUI Example 2" );
  glutDisplayFunc( myGlutDisplay );
  glutReshapeFunc( myGlutReshape );  
  glutKeyboardFunc( myGlutKeyboard );
  glutMotionFunc( myGlutMotion );
  glutMouseFunc( myGlutMouse );
 
  
 
  /****************************************/
  /*          Enable z-buferring          */
  /****************************************/

  glEnable(GL_DEPTH_TEST); 

  /****************************************/
  /*         Here's the GLUI code         */
  /****************************************/ 

  GLUI *glui = GLUI_Master.create_glui( "Key Window", 0, 360, 30 ); /* name, flags,
								 x, and y */ 
glui->add_separator();
glui->add_separator(); 

  //edittext = glui->add_edittext( "Text:", GLUI_EDITTEXT_TEXT, text, 3, control_cb );
  GLUI_Panel *obj_panel = glui->add_panel( "key panel" );
  //radio = glui->add_radiogroup_to_panel(obj_panel,&obj,4,control_cb);

glui->add_button_to_panel( obj_panel,"KEY", 1,(GLUI_Update_CB)bob ); 
glui->add_button_to_panel( obj_panel,"DELETE", 2,(GLUI_Update_CB)bob ); 
glui->add_button_to_panel( obj_panel,"PLAY ->", 3,(GLUI_Update_CB)bob );
glui->add_button_to_panel( obj_panel,"STOP ->", 7,(GLUI_Update_CB)bob );
glui->add_button_to_panel( obj_panel,"RENDER SEQ ->", 6,(GLUI_Update_CB)bob );
glui->add_checkbox_to_panel( obj_panel,"use input frame seq",&use_i, 8,(GLUI_Update_CB)ralph );
glui->add_checkbox_to_panel( obj_panel,"show picture for play",&no_im, 8,(GLUI_Update_CB)ralph );
glui->add_checkbox_to_panel( obj_panel,"use easy in easy out (not linear)",&sininout, 8,(GLUI_Update_CB)ralph );
glui->add_button_to_panel( obj_panel,"PRINT ->", 3,(GLUI_Update_CB)ralph );
glui->add_spinner_to_panel(obj_panel, "PB SPEED:",GLUI_SPINNER_INT, &zx,9, control_cb ); 
glui->add_separator(); 
glui->add_separator(); 
glui->add_button( "EXIT", 0,(GLUI_Update_CB)exit ); 
glui->set_main_gfx_window( main_window );  
 
  
 /****** file window ******/ 
 
  cmd_line_glui = GLUI_Master.create_glui( "File GUI:", 
						 0, 30, 360 ); 
  
GLUI_Panel *io_panel = cmd_line_glui->add_panel( "io buttons" ); 
 
cmd_line_glui->add_separator_to_panel(io_panel); 
 
  cmd_line_glui->add_button_to_panel( io_panel,"open keys ->", 2,(GLUI_Update_CB)ralph ); 
  cmd_line_glui->add_button_to_panel( io_panel,"save keys ->", 1,(GLUI_Update_CB)ralph ); 
  cmd_line_glui->add_button_to_panel( io_panel,"open image ->", 4,(GLUI_Update_CB)ralph ); 
  cmd_line_glui->add_button_to_panel( io_panel,"save image ->", 5,(GLUI_Update_CB)ralph );
  cmd_line_glui->add_button_to_panel( io_panel,"val img squnce->", 9,(GLUI_Update_CB)ralph ); 
 
  cmd_line_glui->add_button_to_panel( io_panel,"update image ->", 6,(GLUI_Update_CB)ralph );
  
  
  
cmd_line_glui->add_column(true); 
 
 GLUI_Panel *file_names = cmd_line_glui->add_panel( "file names" ); 
 
cmd_line_glui->add_separator_to_panel(file_names); 
 
cmd_line = cmd_line_glui->add_edittext_to_panel( file_names,"input Keyframe File:", GLUI_EDITTEXT_TEXT, inputf,3, control_cb ); 
cmd_line->set_w( 200 ); 
cmd_line = cmd_line_glui->add_edittext_to_panel( file_names,"output keyframe File:", GLUI_EDITTEXT_TEXT, outputf,3, control_cb ); 
cmd_line->set_w( 200 ); 
cmd_line = cmd_line_glui->add_edittext_to_panel( file_names,"input image File:", GLUI_EDITTEXT_TEXT, inputi,3, control_cb ); 
cmd_line->set_w( 200 ); 
cmd_line = cmd_line_glui->add_edittext_to_panel( file_names,"output image File:", GLUI_EDITTEXT_TEXT, outputi,3, control_cb ); 
cmd_line->set_w( 200 ); 
cmd_line = cmd_line_glui->add_edittext_to_panel( file_names,"Infile sequence:", GLUI_EDITTEXT_TEXT, sini,3, control_cb ); 
cmd_line->set_w( 200 ); 
cmd_line = cmd_line_glui->add_edittext_to_panel( file_names,"Outfile sequence:", GLUI_EDITTEXT_TEXT, souti,3, control_cb ); 
cmd_line->set_w( 200 );  

glui->set_main_gfx_window( main_window );   
  
 
 /****** Curve window ******/ 
 
curve_glui = GLUI_Master.create_glui( "Curve GUI:",0, 400, 300 );  
 
GLUI_Panel *curve_panel = curve_glui->add_panel("Curve Manips" ); 
 
curve_glui->add_separator_to_panel(curve_panel); 
 
curve_glui->add_statictext_to_panel( curve_panel,"Curve Co Ords" ); 
 
spinner  = curve_glui->add_spinner_to_panel(curve_panel, "x co-ord:",GLUI_SPINNER_FLOAT, &xc,4, bob ); 
   
spinner  = curve_glui->add_spinner_to_panel( curve_panel,"y co-ord:",GLUI_SPINNER_FLOAT, &yc,5, bob ); 
 
curve_glui->add_separator_to_panel(curve_panel); 
 
curve_glui->add_statictext_to_panel( curve_panel,"Frame Properties" ); 
 
spinner  = curve_glui->add_spinner_to_panel(curve_panel, "frame:",GLUI_SPINNER_INT, &frame,2, control_cb ); 
spinner->set_int_limits( 0, 200 ); 
spinner  = curve_glui->add_spinner_to_panel( curve_panel,"endframe:",GLUI_SPINNER_INT, &length,2, control_cb ); 
spinner->set_int_limits( 0, 200 ); 
curve_glui->add_statictext_to_panel( curve_panel,"positional properties" ); 
 
 
spinner  = curve_glui->add_spinner_to_panel( curve_panel,"pol_max:",GLUI_SPINNER_FLOAT, &polmax,2,control_cb ); 
spinner->set_int_limits( 0, 100 );    
spinner  = curve_glui->add_spinner_to_panel(curve_panel, "position width:",GLUI_SPINNER_FLOAT,&pph,2,control_cb ); 
spinner->set_int_limits( 0, 100 ); 
spinner  = curve_glui->add_spinner_to_panel( curve_panel,"position height:",GLUI_SPINNER_FLOAT,&ppw,2,control_cb ); 
spinner->set_int_limits( 0, 100 );     /* these last two are wrong way round */


glui->set_main_gfx_window( main_window );

  /* We register the idle callback with GLUI, *not* with GLUT */
  GLUI_Master.set_glutIdleFunc( myGlutIdle );

  glutMainLoop();  
}
