#ifndef key_h
#define key_h

#include "glui.h"
#include <time.h>
#include <stdio.h>


struct Keyframe {
		int f_no;
		float x_co, y_co, posxx, posyy,pola ;
		struct Keyframe *Next_key;
				};

typedef struct Keyframe KEYFRAME;
typedef KEYFRAME *KEYFRAMEPTR;

KEYFRAMEPTR startptr = NULL;

void insert(KEYFRAMEPTR *sptr, float x_c, float y_c, float px, float py, float pl, int frame_no)
{
	KEYFRAMEPTR newptr, previousptr, currentptr;

	newptr =   (KEYFRAMEPTR) malloc(sizeof(KEYFRAME));

	if (newptr !=NULL) {
		newptr->x_co = x_c;
		newptr->y_co = y_c;
		newptr->posxx = px;
		newptr->posyy = py;
		newptr->pola = pl;		
		newptr->f_no = frame_no;
		newptr->Next_key = NULL;



		previousptr =NULL;
		currentptr = *sptr;

		while(currentptr != NULL && frame_no > currentptr->f_no){
			previousptr = currentptr;
			currentptr = currentptr->Next_key;
		}
		if(previousptr==NULL) {
			newptr->Next_key = *sptr;
			*sptr = newptr;
							}

		else{
			previousptr->Next_key = newptr;
			newptr->Next_key = currentptr;
			}
		}
		else
			printf("%c not inserted. no memory available: \n", frame_no);
}

int deletef(KEYFRAMEPTR *sptr, int frame_no)
{
	KEYFRAMEPTR tempptr, previousptr, currentptr;

	
	if (frame_no == (*sptr)->f_no)
	{
		tempptr = *sptr;
		*sptr = (*sptr)->Next_key;
		free(tempptr);
		return frame_no;
	}

	else{
		previousptr = *sptr;
		currentptr = (*sptr)->Next_key;

		while (currentptr != NULL && currentptr->f_no != frame_no) {
			previousptr = currentptr;
			currentptr = currentptr->Next_key;
		}

		if (currentptr !=NULL) 
		{
			tempptr = currentptr;
			previousptr->Next_key = currentptr->Next_key;
			free(tempptr);
			return frame_no;
		}
	}
	return '\0';
}

void printlist(KEYFRAMEPTR currentptr)
{
	if(currentptr == NULL)
		printf("No keys set.\n\n");
	else {
		printf("the keys are: \n");

		while (currentptr != NULL)
		{
			printf("%d  -->", currentptr->f_no);
			currentptr = currentptr->Next_key;
		}
		printf("NULL\n\n"); 
	}
}
#endif
